1c5d8b7e7bb0b02bb6217fdf3834ce82f55e526a
[grml-debootstrap.git] / grml-debootstrap
1 #!/bin/bash
2 # Filename:      grml-debootstrap
3 # Purpose:       wrapper around debootstrap for installing plain Debian via Grml
4 # Authors:       grml-team (grml.org), (c) Michael Prokop <mika@grml.org>
5 # Bug-Reports:   see http://grml.org/bugs/
6 # License:       This file is licensed under the GPL v2+
7 ################################################################################
8
9 # error_handler {{{
10 [ -n "$REPORT_TRAP_ERR" ] || REPORT_TRAP_ERR='no'
11 [ -n "$FAIL_TRAP_ERR" ] || FAIL_TRAP_ERR='no'
12
13 error_handler() {
14    last_exit_code="$?"
15    last_bash_command="$BASH_COMMAND"
16    if [ "$REPORT_TRAP_ERR" = "yes" ]; then
17       echo "Unexpected non-zero exit code $last_exit_code in ${BASH_SOURCE[*]} at line ${BASH_LINENO[*]} detected!
18 last bash command: $last_bash_command"
19    fi
20    if [ ! "$FAIL_TRAP_ERR" = "yes" ]; then
21       return
22    fi
23    ## Check if "bailout" function is available.
24    ## This is not the case in chroot-script.
25    if command -v bailout >/dev/null 2>&1; then
26       bailout 1
27    else
28       echo 'FAIL_TRAP_ERR is set to "yes", exit 1.'
29       exit 1
30    fi
31 }
32
33 if [ "$REPORT_TRAP_ERR" = "yes" ] || [ "$FAIL_TRAP_ERR" = "yes" ]; then
34    set -E
35    set -o pipefail
36    trap "error_handler" ERR
37    export -f "error_handler"
38 fi
39 # }}}
40
41 # variables {{{
42 PN="$(basename "$0")"
43 if [[ -d "$(dirname "$(command -v "$0")")"/.git ]]; then
44   VERSION="$(git describe | sed 's|^v||')"
45 else
46   VERSION="$(dpkg-query --show --showformat='${Version}' "$PN")"
47 fi
48 VERSION="${VERSION:-unknown}"
49 MNTPOINT="/mnt/debootstrap.$$"
50
51 # defaults
52 [ -n "$CHROOT_SCRIPTS" ] || CHROOT_SCRIPTS='yes'
53 [ -n "$CONFFILES" ] || CONFFILES='/etc/debootstrap'
54 [ -n "$DEBCONF" ] || DEBCONF='yes'
55 [ -n "$DEBIAN_FRONTEND" ] || DEBIAN_FRONTEND='noninteractive'
56 [ -n "$DEBOOTSTRAP" ] || DEBOOTSTRAP='debootstrap'
57 [ -n "$DEFAULT_LANGUAGE" ] || DEFAULT_LANGUAGE='en_US:en'
58 [ -n "$DEFAULT_LOCALES" ] || DEFAULT_LOCALES='en_US.UTF-8'
59 [ -n "$DISK_IDENTIFIER" ] || DISK_IDENTIFIER='26ada0c0-1165-4098-884d-aafd2220c2c6'
60 [ -n "$EXTRAPACKAGES" ] || EXTRAPACKAGES='yes'
61 [ -n "$FALLBACK_MIRROR" ] || FALLBACK_MIRROR='http://deb.debian.org/debian'
62 [ -n "$FIXED_DISK_IDENTIFIERS" ] || FIXED_DISK_IDENTIFIERS="no"
63 [ -n "$FORCE" ] || FORCE=''
64 [ -n "$HOSTNAME" ] || HOSTNAME='grml'
65 [ -n "$INITRD" ] || INITRD='yes'
66 [ -n "$INSTALL_NOTES" ] || INSTALL_NOTES='/etc/debootstrap/install_notes'
67 [ -n "$LOCALES" ] || LOCALES='yes'
68 [ -n "$MIRROR" ] || MIRROR="$FALLBACK_MIRROR"
69 [ -n "$MKFS" ] || MKFS='mkfs.ext4'
70 [ -n "$MKFS_OPTS" ] || MKFS_OPTS=''
71 [ -n "$PACKAGES" ] || PACKAGES='yes'
72 [ -n "$POST_SCRIPTS" ] || POST_SCRIPTS='yes'
73 [ -n "$PRE_SCRIPTS" ] || PRE_SCRIPTS='yes'
74 [ -n "$RECONFIGURE" ] || RECONFIGURE='console-data'
75 [ -n "$RELEASE" ] || RELEASE='stretch'
76 [ -n "$RM_APTCACHE" ] || RM_APTCACHE='yes'
77 [ -n "$SCRIPTS" ] || SCRIPTS='no' # deprecated, replaced by POST_SCRIPTS
78 [ -n "$SECURE" ] || SECURE='yes'
79 [ -n "$TIMEZONE" ] || TIMEZONE='Europe/Vienna'
80 [ -n "$TUNE2FS" ] || TUNE2FS='tune2fs -c0 -i0'
81 [ -n "$UPGRADE_SYSTEM" ] || UPGRADE_SYSTEM='yes'
82 [ -n "$VMSIZE" ] || VMSIZE="2G"
83
84 # inside the chroot system locales might not be available, so use minimum:
85 export LANG=C
86 export LC_ALL=C
87 export LANGUAGE=C
88
89 # make sure interactive mode is only executed when
90 # using an empty configuration file or option --interactive
91 INTERACTIVE=''
92 # }}}
93
94 # help text {{{
95 usage() {
96   echo "$PN - wrapper around debootstrap for installing Debian
97
98 Usage: $PN [options]
99
100 Bootstrap options:
101
102   -m, --mirror <URL>     Mirror which should be used for apt-get/aptitude.
103   -i, --iso <mnt>        Mountpoint where a Debian ISO is mounted to, for use
104                          instead of fetching packages from a mirror.
105   -r, --release <name>   Release of new Debian system (default: stretch).
106   -t, --target <target>  Target partition (/dev/...) or directory where the
107                          system should be installed to.
108   -p, --mntpoint <mnt>   Mountpoint used for mounting the target system,
109                          has no effect if -t is given and represents a directory.
110       --debopt <params>  Extra parameters passed to the debootstrap command.
111       --interactive      Use interactive mode (frontend).
112       --nodebootstrap    Skip debootstrap, only do configuration to the target.
113       --grub <device>    Target for grub installation. Usage example: /dev/sda
114       --efi <device>     Target for EFI installation. Usage example: /dev/sda1
115       --arch <arch>      Set target architecture, use for installing i386 on amd64.
116       --filesystem <fs>  Filesystem that should be used when target is a partition
117                          or Virtual Machine (see --vmfile).
118       --force            Do not prompt for user acknowledgement.
119
120 Options for Virtual Machine deployment:
121
122       --vm               Set up a Virtual Machine on an existing block device
123                          instead of plainly installing to a partition or
124                          directory. Needs to be combined with --target.
125                          Example: --vm --target /dev/mapper/your-vm-disk
126       --vmfile           Like --vm, but install into a regular file (created by
127                          'qemu-img create -f raw ...') instead.
128                          Example: --vmfile --target /mnt/sda1/qemu.img
129       --vmsize <size>    Use specified size for size of VM file (default: 2G).
130                          Syntax as supported by qemu-img, like: --vmsize 3G
131
132 Configuration options:
133
134   -c, --config <file>      Use specified configuration file, defaults to
135                              /etc/debootstrap/config
136   -d, --confdir <path>     Place of config files for debootstrap, defaults
137                              to /etc/debootstrap
138       --packages <file>    Install packages defined in specified list file
139                              instead of using /etc/debootstrap/packages.
140       --nopackages         Skip installation of packages defined in
141                              /etc/debootstrap/packages
142       --nokernel           Skip installation of default kernel images.
143       --nointerfaces       Do not copy /etc/network/interfaces from host system
144                            to target system.
145                            (This option is automatically enabled when using --vmfile.)
146       --defaultinterfaces  Install a default /etc/network/interfaces file (enabling
147                            DHCP for eth0) instead of taking over config from host system.
148       --debconf <file>     Pre-seed packages using specified pre-seed db file.
149       --grmlrepos          Enable Grml's Debian repository (deb.grml.org).
150       --backportrepos      Enable Debian's backports repository (backports.debian.org).
151       --keep_src_list      Do not overwrite user provided apt sources.list.
152       --contrib            Enable 'contrib' in COMPONENTS (defaults to 'main' only).
153       --non-free           Enable non-free in COMPONENTS (defaults to 'main' only).
154       --hostname <name>    Hostname of Debian system.
155       --nopassword         Do not prompt for the root password.
156       --password <pwd>     Use specified password as password for user root.
157       --bootappend <line>  Add specified appendline to kernel whilst booting.
158       --chroot-scripts <d> Execute chroot scripts from specified directory.
159       --pre-scripts <dir>  Execute scripts from specified directory (before chroot-scripts).
160       --scripts <dir>      Execute scripts from specified directory (after chroot-scripts).
161       --remove-configs     Delete grml-debootstrap configuration files from installed system.
162
163 Other options:
164
165   -v, --verbose            Increase verbosity.
166       --debug              Execute in very verbose way.
167   -h, --help               Print this usage information and exit.
168   -V, --version            Show summary of options and exit.
169
170 Usage examples can be found in the grml-debootstrap manpage.
171 Send bugreports to the grml-team: bugs (at) grml.org || http://grml.org/bugs/
172 "
173 }
174
175 if [ "$1" = '-h' ] || [ "$1" = '-help' ] || [ "$1" = "--help" ] ; then
176    usage
177    echo 'Please notice that this script requires root permissions!'
178    exit 0
179 fi
180 # }}}
181
182 # early helper functions {{{
183 GOOD='\e[32;01m'
184 BAD='\e[31;01m'
185 WARN='\e[33;01m'
186 NORMAL='\e[0m'
187
188 einfo() {
189   einfon "$1\\n"
190   return 0
191 }
192
193 einfon() {
194   [ "${RC_ENDCOL}" != "yes" ] && [ "${LAST_E_CMD}" = "ebegin" ] && echo
195   printf " %s*%s $*" "${GOOD}" "${NORMAL}"
196   LAST_E_CMD=einfon
197   return 0
198 }
199
200 ewarn() {
201   printf " %s*%s $*\\n" "${WARN}" "${NORMAL}"
202   return 0
203 }
204
205 eerror() {
206   [ "${RC_ENDCOL}" != "yes" ] && [ "${LAST_E_CMD}" = "ebegin" ] && echo
207   printf " %s*%s $*\\n" "${BAD}" "${NORMAL}" >&2
208   LAST_E_CMD=eerror
209   return 0
210 }
211
212 eend() {
213   local retval="${1:-0}"
214   shift
215   if [ "$retval" -gt 0 ]; then
216     printf " %s-> Failed (rc=%s)%s\\n" "${BAD}" "${retval}" "${NORMAL}"
217   fi
218   return "$retval"
219 }
220
221 check4root(){
222   if [ "$(id -u 2>/dev/null)" != 0 ] ; then
223     echo 1>&2 "Error: please run this script with uid 0 (root)." ; return 1
224   fi
225 }
226
227 check4progs(){
228   local RC=''
229   for arg in "$@" ; do
230     command -v "$arg" >/dev/null 2>&1 || RC="$arg"
231   done
232   if [ -n "$RC" ] ; then
233      echo "$RC not installed"
234      return 1
235   fi
236 }
237 # }}}
238
239 # helper functions {{{
240 cleanup() {
241   if [ -n "$CHROOT_VARIABLES" ] ; then
242     einfo "Removing ${CHROOT_VARIABLES}" ; rm "$CHROOT_VARIABLES" ; eend $?
243   fi
244
245   if [ -n "$STAGES" ] ; then
246     einfo "Removing ${STAGES}" ; rmdir "$STAGES" ; eend $?
247   fi
248
249   # Remove temporary mountpoint again
250   if echo "$MNTPOINT" | grep -q '/mnt/debootstrap\.' ; then
251     rmdir "$MNTPOINT" 2>/dev/null
252   fi
253
254   # make sure $TARGET is not mounted when exiting grml-debootstrap
255   if [ -n "$MNTPOINT" ] ; then
256     if grep -q "$MNTPOINT" /proc/mounts ; then
257       # make sure nothing is left inside chroot so we can unmount it
258       for service in ssh mdadm ; do
259         if [ -x "${MNTPOINT}/etc/init.d/${service}" ] ; then
260           chroot "$MNTPOINT" "/etc/init.d/${service}" stop
261         fi
262       done
263
264       [ -x "$MNTPOINT"/bin/umount ] && chroot "$MNTPOINT" umount -a >/dev/null 2>&1
265
266       # ugly, but make sure we really don't leave anything (/proc /proc and
267       # /dev /dev are intended, trying to work around timing issues, see #657023)
268       for ARG in /sys /proc /proc /dev/pts /dev/pts /dev /dev ; do
269         [ -x "$MNTPOINT"/bin/umount ] && chroot "$MNTPOINT" umount $ARG >/dev/null 2>&1
270         umount "$MNTPOINT"/$ARG >/dev/null 2>&1
271       done
272
273       if [ -n "$ISODIR" ] ; then
274         [ -d "$MNTPOINT/$ISODIR" ] && umount "$MNTPOINT/$ISODIR" >/dev/null 2>&1
275       fi
276
277       if [ -n "$DIRECTORY" ] ; then
278         einfo "Not unmounting $MNTPOINT as you requested me to install into a directory of your own choice." ; eend 0
279       else
280         einfo "Unmounting $MNTPOINT"
281         umount "$MNTPOINT"
282         eend $?
283       fi
284
285       if [ -n "$STAGES" ] ; then
286         echo -n "Removing stages directory ${STAGES}: "
287         rm -rf "$STAGES" && echo 'done'
288       fi
289
290       # remove directory only if we used the default with process id inside the name
291       if echo "$MNTPOINT" | grep -q '/mnt/debootstrap\.' ; then
292         einfo "Removing directory ${MNTPOINT}"
293         rmdir "$MNTPOINT"
294         eend $?
295       fi
296     fi
297   fi
298
299   if [ -n "${ORIG_TARGET}" ] ; then
300     einfo "Removing loopback mount of file ${ORIG_TARGET}."
301     kpartx -d "${ORIG_TARGET}" ; eend $?
302   fi
303 }
304
305 # we want to exit smoothly and clean:
306 bailout(){
307
308   cleanup
309
310   [ -n "$1" ] && EXIT="$1" || EXIT="1"
311   [ -n "$2" ] && einfo "Notice: remove $STAGES/$2 to reexecute the stage"
312
313   exit "$EXIT"
314 }
315 trap bailout HUP INT QUIT TERM
316
317 # we want to execute all the functions only once, simple check for it:
318 stage() {
319   if [ -n "$2" ] ; then
320      echo "$2" > "${STAGES}/${1}"
321      return 0
322   elif grep -q 'done' "${STAGES}/${1}" 2>/dev/null ; then
323      ewarn "Notice: stage $1 has been executed already, skipping execution therefore." ; eend 0
324      ewarn "  To reexecute it clean up the according directory inside $STAGES" ; eend 0
325      return 1
326   fi
327 }
328 # }}}
329
330 # make sure we have what we need {{{
331 check4progs debootstrap || bailout 1
332 # }}}
333
334 # source main configuration file {{{
335 if [ -r /etc/debootstrap/config ] ; then
336   # shellcheck disable=SC1091
337   . /etc/debootstrap/config
338 fi
339 # }}}
340
341 # cmdline handling {{{
342 CMDLINE_OPTS=mirror:,iso:,release:,target:,mntpoint:,debopt:,defaultinterfaces,interactive,nodebootstrap,nointerfaces,nokernel,nopackages,filesystem:,config:,confdir:,packages:,chroot-scripts:,scripts:,post-scripts:,pre-scripts:,debconf:,vm,vmfile,vmsize:,keep_src_list,hostname:,password:,nopassword,grmlrepos,backportrepos,bootappend:,grub:,efi:,arch:,insecure,verbose,help,version,force,debug,contrib,non-free,remove-configs
343
344 _opt_temp=$(getopt --name grml-debootstrap -o +m:i:r:t:p:c:d:vhV --long \
345   $CMDLINE_OPTS -- "$@")
346
347 if [ $? != 0 ]; then
348   eerror "Try 'grml-debootstrap --help' for more information."; eend 1; exit 1
349 fi
350 eval set -- "$_opt_temp"
351
352 while :; do
353   case "$1" in
354
355   # == Bootstrap options
356   --mirror|-m)         # Mirror which should be used for apt-get/aptitude
357     shift; _opt_mirror="$1"
358     ;;
359   --iso|-i)            # Mountpoint where a Debian ISO is mounted to
360     shift; _opt_iso="$1"
361     ;;
362   --release|-r)        # Release of new Debian system
363     shift; _opt_release="$1"
364     ;;
365   --target|-t)         # Target partition (/dev/...) or directory
366     shift; _opt_target="$1"
367     ;;
368   --vm)                # Virtual machine image (no file)
369     _opt_vm="T"
370     ;;
371   --vmfile)            # Virtual machine file
372     _opt_vmfile="T"
373     ;;
374   --vmsize)            # size of Virtual machine file
375     shift; _opt_vmsize="$1"
376     ;;
377   --mntpoint|-p)       # Mountpoint used for mounting the target system
378     shift; _opt_mntpoint="$1"
379     ;;
380   --debopt)            # Extra parameters passed to the debootstrap command
381     shift; _opt_debopt="$1"
382     ;;
383   --filesystem)        # Filesystem that should be used
384     shift; _opt_filesystem="$1"
385     ;;
386   --interactive)       # Use interactive mode (frontend)
387     _opt_interactive=T
388     ;;
389   --nodebootstrap)     # Skip debootstrap, only do configuration to the target
390     _opt_nodebootstrap=T
391     ;;
392   --nopackages)        # Skip installation of packages defined in /etc/debootstrap/packages
393     _opt_nopackages=T
394     ;;
395   --arch)              # Target architecutre
396     shift; _opt_arch="$1"
397     ;;
398   # just for backwards compatibility
399   --insecure)
400     _opt_insecure=T
401     ;;
402   #
403
404   # == Configuration options
405   --config|-c)         # Use specified configuration file, defaults to /etc/debootstrap
406     shift; _opt_config="$1"
407     ;;
408   --confdir|-d)        # Place of config files for debootstrap, defaults to /etc/debootstrap
409     shift; _opt_confdir="$1"
410     ;;
411   --packages)          # Install packages defined in specified file
412     shift; _opt_packages="$1"
413     _opt_packages_set=T
414     ;;
415   --debconf)           # Pre-seed packages using specified file
416     shift; _opt_debconf="$1"
417     _opt_debconf_set=T
418     ;;
419   --pre-scripts)       # Execute scripts from specified directory (before chroot-scripts).
420     shift; _opt_pre_scripts="$1"
421     _opt_pre_scripts_set=T
422     ;;
423   --scripts)           # Execute scripts from specified directory [NOTE: deprecated, replaced via --post-scripts]
424     shift; _opt_scripts="$1"
425     _opt_scripts_set=T
426     ;;
427   --post-scripts)       # Execute scripts from specified directory
428     shift; _opt_post_scripts="$1"
429     _opt_post_scripts_set=T
430     ;;
431   --chroot-scripts)   # Execute chroot scripts from specified directory
432     shift; _opt_chroot_scripts="$1"
433     _opt_chroot_scripts_set=T
434     ;;
435   --keep_src_list)     # Do not overwrite user provided apt sources.list
436     _opt_keep_src_list=T
437     ;;
438   --hostname)          # Hostname of Debian system
439     shift; _opt_hostname="$1"
440     ;;
441   --password)          # Use specified password as password for user root
442     shift; _opt_password="$1"
443     ;;
444   --defaultinterfaces) # Install default /etc/network/interfaces
445     _opt_defaultinterfaces=T
446     ;;
447   --nointerfaces)      # Skip installation of /etc/network/interfaces
448     _opt_nointerfaces=T
449     ;;
450   --nokernel)          # Skip installation of default kernel images
451     _opt_nokernel=T
452     ;;
453   --nopassword)        # Skip password dialog
454     _opt_nopassword=T
455     ;;
456   --grmlrepos)         # Enable Grml repository
457     _opt_grmlrepos=T
458     ;;
459   --backportrepos)     # Enable Debian backports repository
460     _opt_backportrepos=T
461     ;;
462   --bootappend)        # Add specified appendline to kernel whilst booting
463     shift; _opt_bootappend="$1"
464     ;;
465   --grub)              # Target for grub installation. Use grub syntax for specifying
466     shift; _opt_grub="$1"
467     ;;
468   --efi)               # Target for EFI boot installation
469     shift; _opt_efi="$1"
470     ;;
471   --contrib)           # Add 'contrib' to list of components
472     _opt_contrib=T
473     ;;
474   --non-free)          # Add 'non-free' to list of components
475     _opt_non_free=T
476     ;;
477   --remove-configs)    # Drop config files from installed system
478     _opt_remove_configs=T
479     ;;
480
481   # == Other options
482   --verbose|-v)        # Increase verbosity
483     if [ "$_opt_verbose" ]; then
484       _opt_verbose=$( _opt_verbose + 1 )
485     else
486       _opt_verbose=1
487     fi
488     ;;
489   --debug)             # Execute in debug mode
490     _opt_debug=T
491     ;;
492   --help|-h)           # Print usage information and exit
493     _opt_help=T
494     ;;
495   --version|-V)        # Show version information and exit
496     _opt_version=T
497     ;;
498   --force)             # Do not prompt for user input
499     _opt_force=T
500     ;;
501   --)
502     shift; break
503     ;;
504   *)
505     eerror "Internal getopt error!"; eend 1 ; exit 1
506     ;;
507   esac
508   shift
509 done
510
511 # == business-logic of command line parameter-processing
512
513 # source configuration file in <confdir> if supplied. {{{
514 [ "$_opt_confdir" ] && {
515   CONFFILES=$_opt_confdir
516   einfo "Using config files under $CONFFILES/."
517   if ! [ -r "$CONFFILES/config" ] ; then
518     eerror "Error: config file $CONFFILES/config not found."; eend 1; bailout 1
519   fi
520   # shellcheck disable=SC1091 source=config
521   if ! . "$CONFFILES/config" ; then
522     eerror "Error reading config file $CONFFILES/config" ; eend 1 ; bailout 1
523   fi
524   # restore the command line parameter value
525   CONFFILES=$_opt_confdir
526 }
527 # }}}
528
529 [ "$_opt_mirror" ]              && MIRROR=$_opt_mirror
530 [ "$_opt_iso" ]                 && ISO=$_opt_iso
531 [ "$_opt_release" ]             && RELEASE=$_opt_release
532 [ "$_opt_target" ]              && TARGET=$_opt_target
533 [ "$_opt_vm" ]                  && VIRTUAL=1
534 [ "$_opt_vmfile" ]              && VMFILE=1 && VIRTUAL=1
535 [ "$_opt_vmsize" ]              && VMSIZE=$_opt_vmsize
536 [ "$_opt_mntpoint" ]            && MNTPOINT=$_opt_mntpoint
537 [ "$_opt_debopt" ]              && DEBOOTSTRAP_OPT=$_opt_debopt
538 [ "$_opt_interactive" ]         && INTERACTIVE=1
539 [ "$_opt_config" ]              && CONFIGFILE=$_opt_config
540 [ "$_opt_filesystem" ]          && MKFS="mkfs.$_opt_filesystem"
541 [ "$_opt_packages_set" ]        && PACKAGES='yes'
542 [ "$_opt_nopackages" ]          && PACKAGES=''
543 [ "$_opt_debconf_set" ]         && DEBCONF='yes'
544 [ "$_opt_post_scripts_set" ]    && POST_SCRIPTS='yes'
545 [ "$_opt_pre_scripts_set" ]     && PRE_SCRIPTS='yes'
546 [ "$_opt_chroot_scripts_set" ]  && CHROOT_SCRIPTS='yes'
547 [ "$_opt_keep_src_list" ]       && KEEP_SRC_LIST='yes'
548 [ "$_opt_grmlrepos" ]           && GRMLREPOS='yes'
549 [ "$_opt_backportrepos" ]       && BACKPORTREPOS='yes'
550 [ "$_opt_hostname" ]            && HOSTNAME=$_opt_hostname
551 [ "$_opt_password" ]            && ROOTPASSWORD=$_opt_password
552 [ "$_opt_nopassword" ]          && NOPASSWORD='yes'
553 [ "$_opt_defaultinterfaces" ]   && USE_DEFAULT_INTERFACES="true"
554 [ "$_opt_nointerfaces" ]        && NOINTERFACES="true"
555 [ "$_opt_nokernel" ]            && NOKERNEL="true"
556 [ "$_opt_bootappend" ]          && BOOT_APPEND=$_opt_bootappend
557 [ "$_opt_grub" ]                && GRUB=$_opt_grub
558 [ "$_opt_efi" ]                 && EFI=$_opt_efi
559 [ "$_opt_arch" ]                && ARCH=$_opt_arch
560 [ "$_opt_insecure" ]            && echo "Warning: --insecure is deprecated, continuing anyway."
561 [ "$_opt_force" ]               && FORCE=$_opt_force
562 [ "$_opt_verbose" ]             && VERBOSE="-v"
563 [ "$_opt_debug" ]               && DEBUG="true"
564 [ "$_opt_remove_configs" ]      && REMOVE_CONFIGS="yes"
565
566 # make sure main is always included
567 [ -z "$COMPONENTS" ]            && COMPONENTS="main"
568 [ "$_opt_contrib" ]             && COMPONENTS="$COMPONENTS contrib"
569 [ "$_opt_non_free" ]            && COMPONENTS="$COMPONENTS non-free"
570
571 # command line option checks
572 if [ "$_opt_scripts_set" ] ; then
573   ewarn "Deprecation NOTE: --scripts option is deprecated, please switch to --post-scripts instead."
574   SCRIPTS='yes' # deprecated since grml-debootstrap >=0.71
575 fi
576
577 if [ "$_opt_grub" ] && [ "$_opt_vmfile" ] ; then
578   eerror "The --grub option is incompatible with --vmfile, please drop it from your command line."
579   eerror "The --grub option is unneeded as GRUB will be installed automatically."
580   eend 1
581   bailout 1
582 fi
583
584
585 if [ "$DEBUG" = "true" ] ; then
586   set -x
587 fi
588
589 [ "$_opt_help" ] && {
590   usage ; eend 0
591   eend 0
592   exit 0
593 }
594
595 [ "$_opt_version" ] && {
596   einfo "$PN - version $VERSION"
597   einfo "Send bug reports to bugs@grml.org or http://grml.org/bugs/"
598   eend 0
599   exit 0
600 }
601 # }}}
602
603 # check for root permissions {{{
604 if ! check4root ; then
605    echo "For usage instructions please execute '$PN --help'."
606    bailout 1
607 fi
608 # }}}
609
610 # make sure we have what we need {{{
611 if [ -n "$VIRTUAL" ] ; then
612   check4progs kpartx parted qemu-img || bailout 1
613 fi
614 # }}}
615
616 # source specified configuration file {{{
617 if [ -n "$CONFIGFILE" ] ; then
618   einfo "Reading specified config file $CONFIGFILE."
619   # shellcheck disable=SC1091 source=config
620   if ! . "$CONFIGFILE" ; then
621     eerror "Error reading config file $CONFIGFILE" ; eend 1 ; bailout 1
622   fi
623 fi
624 # }}}
625
626 # backwards compatibility checks {{{
627 if [ -n "$GROOT" ] ; then
628    eerror "Error: you seem to have \$GROOT configured."
629    eerror "This variable is no longer supported, please visit the"
630    eerror "grml-debootstrap documentation for details."
631    eend 1
632    bailout 1
633 fi
634
635 if echo "$GRUB" | grep -q '^hd' ; then
636    eerror "Error: this syntax for the grub configuration variable is no longer supported."
637    eerror "Please do not use hd... any longer but /dev/sdX instead."
638    eend 1
639    bailout 1
640 fi
641 # }}}
642
643 # welcome screen {{{
644 welcome_dialog()
645 {
646    dialog --title "$PN" --yesno "Welcome to the interactive configuration of ${PN}.
647 Do you want to continue installing Debian using this frontend?" 0 0 || bailout 0
648 }
649 # }}}
650
651 # ask for target {{{
652 prompt_for_target()
653 {
654   AVAILABLE_PARTITIONS=$(LANG=C fdisk -l 2>/dev/null | \
655                sed 's/*//' | \
656                grep -v 'Extended$' | \
657                gawk -v num=0 -v ORS=' ' '/^\/dev\// {print $1}'; ls /dev/md[0-9]* 2>/dev/null || true);
658
659   if [ -z "$AVAILABLE_PARTITIONS" ] ; then
660      dialog --title "$PN" --trim \
661      --msgbox "Sorry, no partitions found. Please configure your
662      harddisks (see /proc/partitions) using a tool like fdisk,
663      cfdisk, gpart, gparted,..." 0 0
664      bailout 1
665   fi
666
667   PARTITION_LIST=$(for i in $AVAILABLE_PARTITIONS ; do
668                      fs="$(blkid -s TYPE -o value "$i" 2>/dev/null)"
669                      [ -n "$fs" ] || fs='[no_filesystem_yet]'
670                      echo "$i" "$fs"
671                      unset fs
672                    done)
673
674   # shellcheck disable=SC2086
675   TARGET=$(dialog --title "$PN" --single-quoted --stdout \
676          --menu "Please select the target partition:" 0 0 0 \
677          $PARTITION_LIST)
678   [ $? -eq 0 ] || bailout 1
679 }
680 # }}}
681
682 # ask for bootmanager {{{
683 prompt_for_bootmanager()
684 {
685   ADDITIONAL_PARAMS=""
686
687   if echo "$TARGET" | grep -q "/dev/md" ; then
688      MBRPART="all disks of Software RAID $TARGET"
689   else
690      # figure out whole disk device
691      found=
692      for device in /dev/disk/by-id/*
693      do
694         [ "$(readlink -f "$device")" = "${TARGET}" ] || continue
695         found=1
696         break
697      done
698      # shellcheck disable=SC2001
699      [ -n "$found" ] && MBRDISK=$(echo "${device}" | sed -e 's/-part[0-9][0-9]*$//')
700      if [ -e "$MBRDISK" ]; then
701         MBRDISK=$(readlink -f "$MBRDISK")
702      else
703         # fall back to old behaviour
704         # shellcheck disable=SC2001
705         MBRDISK=$(echo "${TARGET}" | sed -e 's/[0-9][0-9]*$//')
706      fi
707
708      MBRPART="MBR of $MBRDISK"
709   fi
710
711   for device in cciss/c0d0 sda hda; do
712     if [ "/dev/$device" != "${MBRDISK}" ]; then
713       grep -q $device /proc/partitions && \
714       ADDITIONAL_PARAMS="$ADDITIONAL_PARAMS:$device:install bootmanager grub into MBR of /dev/$device"
715     fi
716   done
717   ADDITIONAL_PARAMS=${ADDITIONAL_PARAMS#:}
718
719   OIFS="$IFS"; IFS=:
720
721   # shellcheck disable=SC2086
722   GETMBR=$(dialog --stdout --title "$PN" --default-item mbr \
723           --menu "Where do you want to install the bootmanager grub?" 0 0 0 \
724             mbr       "install bootmanager into $MBRPART" \
725             nowhere   "do not install bootmanager at all" \
726           ${ADDITIONAL_PARAMS})
727   [ $? -eq 0 ] || bailout 3
728   IFS="$OIFS"
729
730   case "$GETMBR" in
731     mbr)
732       # /dev/md0: has to be installed in MBR of /dev/md0 and not in /dev/md:
733       if echo "$TARGET" | grep -q "/dev/md" ; then
734         GRUB="$TARGET"
735       else
736         GRUB="$MBRDISK"
737       fi
738       ;;
739     hda)
740       GRUB="/dev/hda"
741       ;;
742     sda)
743       GRUB="/dev/sda"
744       ;;
745     nowhere)
746       GRUB=''
747       ;;
748   esac
749 }
750 # }}}
751
752 # ask for Debian release {{{
753 prompt_for_release()
754 {
755   [ -n "$RELEASE" ] && DEFAULT_RELEASE="$RELEASE" || DEFAULT_RELEASE='stretch'
756   RELEASE="$(dialog --stdout --title "${PN}" --default-item $DEFAULT_RELEASE --menu \
757             "Please enter the Debian release you would like to use for installation:" \
758             0 50 5 \
759             lenny    Debian/5.0 \
760             squeeze  Debian/6.0 \
761             wheezy   Debian/7.0 \
762             jessie   Debian/8.0 \
763             stretch  Debian/9.0 \
764             sid      Debian/unstable)"
765   [ $? -eq 0 ] || bailout
766 }
767 # }}}
768
769 # ask for hostname {{{
770 prompt_for_hostname()
771 {
772   HOSTNAME="$(dialog --stdout --title "${PN}" --inputbox \
773             "Please enter the hostname you would like to use for installation:" \
774             0 0 "$HOSTNAME")"
775   [ $? -eq 0 ] || bailout
776 }
777 # }}}
778
779 # ask for password {{{
780 prompt_for_password()
781 {
782   if [ "$_opt_nopassword" ] ; then
783     einfo "Skip asking for root password as requested."
784     return 0
785   fi
786
787   ROOTPW1='PW1'
788   ROOTPW2='PW2'
789   while [ "$ROOTPW1" != "$ROOTPW2" ]; do
790     ROOTPW1=$(dialog --insecure --stdout --title "${PN}" --passwordbox \
791     "Please enter the password for the root account:" 10 60)
792     [ $? -eq 0 ] || bailout
793
794     ROOTPW2=$(dialog --insecure --stdout --title "${PN}" --passwordbox \
795     "Please enter the password for the root account again for \
796     confirmation:" 10 60)
797     [ $? -eq 0 ] || bailout
798
799     if [ "$ROOTPW1" != "$ROOTPW2" ]; then
800       dialog --stdout --title "${PN}" --ok-label \
801         "Retry" --msgbox "Passwords do not match!" 10 60
802     fi
803   done
804   ROOTPASSWORD="$ROOTPW1"
805 }
806 # }}}
807
808 # ask for Debian mirror {{{
809 prompt_for_mirror()
810 {
811   [ -n "$ISO" ] && DEFAULT_MIRROR='local' || DEFAULT_MIRROR='net'
812
813   CHOOSE_MIRROR=$(dialog --stdout --title "$PN" --default-item $DEFAULT_MIRROR \
814           --menu "Where do you want to install from?" 0 0 0 \
815             net   "install via network (downloading from mirror)" \
816             local "install from local directory/mirror"
817           )
818   [ $? -eq 0 ] || bailout
819
820   if [ "$CHOOSE_MIRROR" = 'net' ] ; then
821      [ -n "$MIRROR" ] || MIRROR='http://deb.debian.org/debian'
822      MIRROR="$(dialog --stdout --title "${PN}" --inputbox \
823                "Please enter Debian mirror you would like to use for installing packages." \
824                0 0 $MIRROR)"
825      [ $? -eq 0 ] || bailout
826   else # CHOOSE_MIRROR == local
827      [ -n "$ISO" ] || ISO='/mnt/mirror'
828      ISO="$(dialog --stdout --title "${PN}" --inputbox \
829                "Please enter directory name you would like to use for installing packages." \
830                0 0 $ISO)"
831      [ $? -eq 0 ] || bailout
832   fi
833 }
834 # }}}
835
836 # software raid setup {{{
837 config_swraid_setup()
838 {
839 TMPFILE=$(mktemp)
840
841 # Currently we support only raid1:
842 RAIDLEVEL='raid1'
843
844 MD_LIST=$(for i in $(seq 0 9) ; do
845             awk '{print $4}' /proc/partitions | grep -q "md$i" || \
846             echo "/dev/md$i /dev/md$i"
847           done)
848
849 # shellcheck disable=SC2086
850 TARGET=$(dialog --stdout --title "$PN" --default-item /dev/md0 \
851 --menu "Which device do you want to use for ${RAIDLEVEL}?
852
853 Notice: activated devices will not be listed for security reasons. Anyway, please make sure the selected device is not in use already!" 0 0 0 \
854 $MD_LIST)
855 [ $? -eq 0 ] || bailout 20
856
857 AVAILABLE_PARTITIONS=$(LANG=C fdisk -l 2>/dev/null | \
858              sed 's/*//' | \
859              grep -v 'Extended$' | \
860              gawk -v num=0 -v ORS=' ' '/^\/dev\// {print $1}')
861 [ -n "$AVAILABLE_PARTITIONS" ] || echo "Fatal error: no partitions available?"
862 PARTITION_LIST=$(for i in $AVAILABLE_PARTITIONS ; do
863                      echo "$i $(blkid -s TYPE -o value "$i" 2>/dev/null || echo '[no_filesystem_yet]') off"
864                  done)
865
866 # shellcheck disable=SC2086
867 dialog --title "$PN" --separate-output \
868        --checklist "Please select the partitions you would like to use for your $RAIDLEVEL on ${TARGET}:" 0 0 0 \
869        $PARTITION_LIST 2>"$TMPFILE"
870 [ $? -eq 0 ] || bailout
871 SELECTED_PARTITIONS="$(cat "$TMPFILE")"
872
873 NUM_PARTITIONS=0
874 while IFS= read -r i; do
875   NUM_PARTITIONS=$(( NUM_PARTITIONS + 1 ))
876 done < "$TMPFILE"
877
878 # force metadata version 0.90 for lenny so old grub can boot from this array.
879 METADATA_VERSION=""
880 if [ "$RELEASE" = "lenny" ]; then
881    METADATA_VERSION="-e0"
882 fi
883
884 ERRORFILE=$(mktemp)
885 # shellcheck disable=SC2086
886 yes | mdadm --create "${TARGET}" --level="${RAIDLEVEL}" \
887       --raid-devices="${NUM_PARTITIONS}" ${METADATA_VERSION} ${SELECTED_PARTITIONS} >/dev/null 2>$ERRORFILE
888 RC=$?
889 if [ "$RC" = 0 ] ; then
890    dialog --title "$PN" --msgbox \
891    "Creating $TARGET was successful." 0 0
892    rm -f "$TMPFILE" "$ERRORFILE"
893 else
894    dialog --title "$PN" --msgbox \
895    "There was an error setting up $TARGET:
896
897 $(cat "$ERRORFILE")
898
899 Exiting." 0 0
900    rm -f "$TMPFILE" "$ERRORFILE"
901    bailout 1
902 fi
903
904 }
905
906 prompt_for_swraid()
907 {
908 if dialog --stdout --title "$PN" \
909           --defaultno --yesno "Do you want to configure Software RAID?
910
911 Please notice that only RAID level 1 is supported by ${PN} currently. Configuration will take place using mdadm." 0 0 ; then
912   config_swraid_setup
913 fi
914 }
915 # }}}
916
917 # user should recheck his configuration {{{
918 # support full automatic installation:
919 checkforrun() {
920    dialog --timeout 10 --title "$PN" \
921           --yesno "Do you want to stop at this stage?
922
923 Notice: you are running ${PN} in non-interactive mode.
924 ${PN} will install Debian ${RELEASE} on ${TARGET}.
925 Last chance to quit. Timeout of 10 seconds running....
926
927 Do you want to stop now?" 0 0 2>/dev/null
928 }
929 # }}}
930
931 # format efi partition {{{
932 format_efi_partition() {
933   if [ -z "$EFI" ] ; then
934     return 0
935   fi
936
937   if ! [ -b "$EFI" ] ; then
938     eerror "Specified efi argument [$EFI] not a valid block device."
939     bailout 1
940   fi
941
942   if fsck.vfat -bn "$EFI" >/dev/null; then
943     einfo "EFI partition $EFI seems to have a FAT filesystem, not modifying." ; eend 0
944   else
945     einfo "EFI partition $EFI doesn't seem to be formatted, creating filesystem."
946     mkfs.fat -F32 -n "EFI System Partition" "$EFI"
947     RC=$?
948     if [ $RC -eq 0 ] ; then
949       eend 0
950     else
951       eerror "Error while creating filesystem on ${EFI}."
952       eend 1
953       bailout 1
954     fi
955   fi
956 }
957 # }}}
958
959 # check for EFI support or try to enable it {{{
960 efi_support() {
961   if lsmod | grep -q efivars ; then
962     einfo "EFI support detected." ; eend 0
963     return 0
964   fi
965
966   if modprobe efivars &>/dev/null ; then
967     einfo "EFI support enabled now." ; eend 0
968     return 0
969   fi
970
971   return 1
972 }
973 # }}}
974
975 # make sure the user is aware of the used configuration {{{
976 checkconfiguration()
977 {
978
979 if efi_support ; then
980   if [ -z "$_opt_efi" ] ; then
981     ewarn "EFI support detected but no --efi option given, please consider enabling it." ; eend 0
982   fi
983 else
984   if [ -n "$_opt_efi" ] ; then
985      eerror "EFI option used but no EFI support detected." ; eend 0
986      bailout 1
987   fi
988 fi
989
990 if [ -n "$AUTOINSTALL" ] ; then
991    if checkforrun ; then
992       eerror "Exiting as requested" ; eend 0
993       bailout 1
994    fi
995 elif [ -n "$INTERACTIVE" ] ; then
996
997    INFOTEXT="Please recheck configuration before execution:
998    "
999    [ -n "$TARGET" ]  && INFOTEXT="$INFOTEXT
1000    Target:          $TARGET"
1001    [ -n "$GRUB" ]    && INFOTEXT="$INFOTEXT
1002    Install grub:    $GRUB"
1003    [ -n "$EFI" ]    && INFOTEXT="$INFOTEXT
1004    Install efi:     $EFI"
1005    [ -n "$RELEASE" ] && INFOTEXT="$INFOTEXT
1006    Using release:   $RELEASE"
1007    [ -n "$HOSTNAME" ] && INFOTEXT="$INFOTEXT
1008    Using hostname:  $HOSTNAME"
1009    [ -n "$MIRROR" ]  && INFOTEXT="$INFOTEXT
1010    Using mirror:    $MIRROR"
1011    [ -n "$ISO" ]  && INFOTEXT="$INFOTEXT
1012    Using ISO:       $ISO"
1013    [ -n "$ARCH" ]  && INFOTEXT="$INFOTEXT
1014    Using arch:      $ARCH"
1015    [ -n "$CONFFILES" ] && INFOTEXT="$INFOTEXT
1016    Config files:    $CONFFILES"
1017
1018    INFOTEXT="$INFOTEXT
1019
1020 Is this ok for you? Notice: selecting 'No' will exit ${PN}."
1021
1022    dialog --title "$PN" --no-collapse \
1023           --yesno "$INFOTEXT" 0 0
1024    [ $? -eq 0 ] || bailout 0
1025
1026 else # if not running automatic installation display configuration and prompt for execution:
1027    einfo "$PN [${VERSION}] - Please recheck configuration before execution:"
1028    echo
1029    echo "   Target:          $TARGET"
1030
1031    # do not display if MNTPOINT is the default one
1032    case "$MNTPOINT" in /mnt/debootstrap*) ;; *) echo "   Mount point:     $MNTPOINT" ;; esac
1033
1034    if [ -n "$VIRTUAL" ] ; then
1035       echo "   Install grub:    yes"
1036    else
1037      [ -n "$GRUB" ]     && echo "   Install grub:    $GRUB" || echo "   Install grub:    no"
1038      [ -n "$EFI" ]      && echo "   Install efi:     $EFI"  || echo "   Install efi:     no"
1039    fi
1040
1041    [ -n "$RELEASE" ]   && echo "   Using release:   $RELEASE"
1042    [ -n "$HOSTNAME" ]  && echo "   Using hostname:  $HOSTNAME"
1043    [ -n "$MIRROR" ]    && echo "   Using mirror:    $MIRROR"
1044    [ -n "$ISO" ]       && echo "   Using ISO:       $ISO"
1045    [ -n "$ARCH" ]      && echo "   Using arch:      $ARCH"
1046    [ -n "$CONFFILES" ] && echo "   Config files:    $CONFFILES"
1047    if [ -n "$VIRTUAL" ] ; then
1048       echo "   Deploying as Virtual Machine."
1049       if [ -n "$VMSIZE" ] && [ -n "$VMFILE" ]; then
1050          echo "   Using Virtual Disk file with size of ${VMSIZE}."
1051       fi
1052    fi
1053
1054    if [ ! -t 0 ] && [ -z "$ROOTPASSWORD" ] && [ -z "$NOPASSWORD" ] ; then
1055       echo
1056       echo "   You do not have a TTY allocated, your password will be shown in"
1057       echo "   plaintext on the terminal! If you are using SSH, try its -t option!"
1058    fi
1059
1060    echo
1061    echo "   Important! Continuing will delete all data from ${TARGET}!"
1062
1063    if [ -n "$FORCE" ] ; then
1064      einfo "Skip user acknowledgement as requested via --force option."
1065    else
1066      echo
1067      einfon "Is this ok for you? [y/N] "
1068      read -r a
1069      if ! [ "$a" = 'y' ] || [ "$a" = 'Y' ] ; then
1070         eerror "Exiting as requested." ; eend 1
1071         bailout 1
1072      fi
1073    fi
1074 fi
1075 }
1076 # }}}
1077
1078 # interactive mode {{{
1079 interactive_mode()
1080 {
1081   check4progs dialog || bailout 1
1082
1083   welcome_dialog
1084
1085   prompt_for_release
1086
1087   prompt_for_swraid
1088
1089   prompt_for_target
1090
1091   prompt_for_bootmanager
1092
1093   prompt_for_hostname
1094
1095   prompt_for_password
1096
1097   prompt_for_mirror
1098 }
1099
1100 # run interactive mode if we didn't get the according configuration yet
1101 if [ -z "$TARGET" ] || [ -n "$INTERACTIVE" ] ; then
1102    # only target might be unset, so make sure the INTERACTIVE flag is set as well
1103    INTERACTIVE=1
1104    interactive_mode
1105 fi
1106 # }}}
1107
1108 # architecture setup {{{
1109 if [ -n "$ARCH" ] ; then
1110    ARCHCMD="--arch $ARCH"
1111    ARCHINFO=" (${ARCH})"
1112 else
1113    ARCH="$(dpkg --print-architecture)"
1114    ARCHCMD="--arch $ARCH"
1115    ARCHINFO=" (${ARCH})"
1116 fi
1117 # }}}
1118
1119 # It is not possible to build amd64 on i686. {{{
1120 CURRENT_ARCH="$(uname -m)"
1121 if [ "$CURRENT_ARCH" != "x86_64" ] ; then
1122    if [ "$ARCH" = "amd64" ] ; then
1123       eerror "It is not possible to build amd64 on $CURRENT_ARCH. Consider installing and booting the 'linux-image-amd64' kernel or using '--arch i386' instead." ; eend 1
1124       bailout 1
1125    fi
1126 fi
1127 # }}}
1128
1129 # Support for generic release codenames is unavailable. {{{
1130 if [ "$RELEASE" = "stable" ] || [ "$RELEASE" = "testing" ] ; then
1131    eerror "Generic release codenames (stable, testing) are unsupported. \
1132 Please use specific codenames such as lenny, squeeze, wheezy, jessie or stretch." ; eend 1
1133    bailout 1
1134 fi
1135 # }}}
1136
1137 checkconfiguration
1138
1139 # finally make sure at least $TARGET is set [the partition for the new system] {{{
1140 if [ -n "$TARGET" ] ; then
1141    SHORT_TARGET="${TARGET##*/}"
1142 else
1143    eerror "Please adjust $CONFFILES/config or..."
1144    eerror "... use the interactive version for configuration before running ${0}" ; eend 1
1145    bailout 1
1146 fi
1147 # }}}
1148
1149 # stages setup {{{
1150 if [ -z "$STAGES" ] ; then
1151    STAGES="/var/cache/grml-debootstrap/stages_${SHORT_TARGET}"
1152    [ -d "$STAGES" ] || mkdir -p "$STAGES"
1153 fi
1154
1155 if [ -r "$STAGES"/grml-debootstrap ] ; then
1156    if grep -q 'done' "${STAGES}/grml-debootstrap" ; then
1157       eerror "Error: grml-debootstrap has been executed already, won't continue therefore."
1158       eerror "If you want to re-execute grml-debootstrap just manually remove ${STAGES}" ; eend 1
1159    fi
1160 fi
1161 # }}}
1162
1163 # partition handling {{{
1164 PARTITION=''
1165 DIRECTORY=''
1166
1167 set_target_directory(){
1168     # assume we are installing into a directory, don't run mkfs and grub related stuff therefore
1169     DIRECTORY=1
1170     MNTPOINT="$TARGET"
1171     MKFS=''
1172     TUNE2FS=''
1173     FSCK=''
1174     # make sure we normalise the path to an absolute directory name so something like:
1175     #  mkdir -p foo/a bar/a; (cd foo; grml-debootstrap -t a)&; (cd bar; grml-debootstrap -t a)&; wait
1176     # works
1177     TARGET="$(readlink -f "$TARGET")"
1178 }
1179
1180 if [ -b "$TARGET" ] || [ -n "$VIRTUAL" ] ; then
1181     PARTITION=1
1182 else
1183     set_target_directory
1184 fi
1185 # }}}
1186
1187 # make sure we have the right syntax when using an iso image {{{
1188 if [ -n "$ISO" ] ; then
1189    case $ISO in
1190       file*) # do nothing
1191       ;;
1192       *)
1193       ISO=file:$ISO
1194       ;;
1195    esac
1196 fi
1197 ISODIR=${ISO##file:}
1198 ISODIR=${ISODIR%%/}
1199 # }}}
1200
1201 # Debian ISOs do not contain signed Release files {{{
1202 if [ -n "$ISO" ] ; then
1203     DEBOOTSTRAP_OPT="$DEBOOTSTRAP_OPT --no-check-gpg"
1204 fi
1205 # }}}
1206
1207 # create filesystem {{{
1208 mkfs() {
1209   if [ -n "$DIRECTORY" ] ; then
1210      einfo "Running grml-debootstrap on a directory, skipping mkfs stage."
1211      return 0
1212   fi
1213
1214   if grep -q "$TARGET" /proc/mounts ; then
1215     eerror "$TARGET already mounted, exiting to avoid possible damage. (Manually unmount $TARGET)" ; eend 1
1216     bailout 1
1217   fi
1218
1219   # mkfs.ext* might prompt with "/dev/sdX# contains a ext* file system
1220   # created on ... Proceed anyway? (y,n)" which we want to skip in force mode
1221   if [ -n "$MKFS" ] && [ -n "$FORCE" ] ; then
1222     case "$MKFS" in
1223       mkfs.ext*)
1224         einfo "Enabling force option (-F) for mkfs.ext* tool as requested via --force switch."
1225         MKFS_OPTS="$MKFS_OPTS -F"
1226         eend 0
1227
1228         ;;
1229     esac
1230   fi
1231
1232   # starting with e2fsprogs 1.43~WIP.2015.05.18-1 mkfs.ext4 enables the metadata_csum feature
1233   # by default, which requires a recent version of tune2fs on the target system then,
1234   # so disable this feature for older Debian releases where it's known to be unsupported
1235   if [ -n "$MKFS" ] && [ "$MKFS" = "mkfs.ext4" ] ; then
1236     case "$RELEASE" in
1237       lenny|squeeze|wheezy|jessie)
1238         # assume a more recent version if we can't identify the version via dpkg-query
1239         local e2fsprogs_version
1240         e2fsprogs_version="$(dpkg-query --show --showformat='${Version}' e2fsprogs 2>/dev/null || echo 1.44)"
1241         if [ -n "$e2fsprogs_version" ] && dpkg --compare-versions "$e2fsprogs_version" ge '1.43~WIP.2015.05.18-1' ; then
1242           einfo "Disabling metadata_csum feature for $MKFS as $RELEASE doesn't support it."
1243           MKFS_OPTS="$MKFS_OPTS -O ^metadata_csum"
1244           eend 0
1245         fi
1246         ;;
1247     esac
1248   fi
1249
1250   if [ -n "$MKFS" ] ; then
1251     einfo "Running $MKFS $MKFS_OPTS on $TARGET"
1252     # shellcheck disable=SC2086
1253     "$MKFS" $MKFS_OPTS "$TARGET" ; RC=$?
1254
1255     if [ "$FIXED_DISK_IDENTIFIERS" = "yes" ] ; then
1256       if ! echo "$MKFS" | grep -q "mkfs.ext" ; then
1257         eerror "Not changing disk uuid for $TARGET because $MKFS doesn't seem to match for ext{2,3,4} file system"
1258         eend 1
1259         bailout 1
1260       else
1261         einfo "Changing disk uuid for $TARGET to fixed (non-random) value $DISK_IDENTIFIER using tune2fs"
1262         tune2fs "$TARGET" -U "$DISK_IDENTIFIER"
1263         eend $?
1264       fi
1265     fi
1266
1267     # make sure /dev/disk/by-uuid/... is up2date, otherwise grub
1268     # will fail to detect the uuid in the chroot
1269     if [ -n "$VIRTUAL" ] ; then
1270       einfo "Virtual environment doesn't require blockdev --rereadpt, skipping therefore"
1271     elif echo "$TARGET" | grep -q "/dev/md" ; then
1272       blockdev --rereadpt "${TARGET}"
1273     else
1274       # if we deploy to /dev/sdX# then let's see if /dev/sdX exists
1275       local main_device="${TARGET%%[0-9]*}"
1276       # sanity check to not try to e.g. access /dev/loop if we get /dev/loop0
1277       if [ -f "/sys/block/$(basename "${main_device}")/$(basename "${TARGET}")/dev" ] ; then
1278         blockdev --rereadpt "$main_device"
1279       else
1280         einfo "No underlying block device for $TARGET identified, skipping blockdev --rereadpt."
1281       fi
1282     fi
1283     # give the system 2 seconds, otherwise we might run into
1284     # race conditions :-/
1285     sleep 2
1286
1287     eend $RC
1288   fi
1289 }
1290 # }}}
1291
1292 # retrieve ID_FS_UUID {{{
1293 identify_target_uuid() {
1294   local device="$1"
1295
1296   if ! [ -b "$device" ] ; then
1297     return 1
1298   fi
1299
1300   eval "$(blkid -o udev "$1" 2>/dev/null)"
1301
1302   if [ -n "$ID_FS_UUID" ] ; then
1303     echo "$ID_FS_UUID"
1304   else
1305     return 1
1306   fi
1307 }
1308 # }}}
1309
1310 # identify TARGET_UUID {{{
1311 mountpoint_to_blockdevice() {
1312   TARGET_UUID=''
1313
1314   TARGET_UUID=$(identify_target_uuid "$TARGET" 2>/dev/null || true)
1315   if [ -n "$TARGET_UUID" ] ; then
1316     einfo "Identified UUID $TARGET_UUID for $TARGET"
1317     return 0
1318   fi
1319
1320   # $TARGET might be a mountpoint and not a blockdevice, search for according entry
1321   for file in /sys/block/*/*/dev ; do
1322     if grep -q "^$(mountpoint -d "${TARGET}")$" "$file" ; then
1323       local dev
1324       dev="${file%/dev}"
1325       dev="/dev/${dev##*/}"
1326       TARGET_UUID=$(identify_target_uuid "$dev" 2>/dev/null || true)
1327
1328       if [ -n "$TARGET_UUID" ] ; then
1329         einfo "Identified UUID $TARGET_UUID for $TARGET (via $file)"
1330         return 0
1331       fi
1332     fi
1333   done
1334 }
1335 # }}}
1336
1337 # modify filesystem settings {{{
1338 tunefs() {
1339   if [ -n "$TUNE2FS" ] && echo "$MKFS" | grep -q "mkfs.ext" ; then
1340      einfo "Disabling automatic filesystem check on $TARGET via tune2fs"
1341      $TUNE2FS "$TARGET"
1342      eend $?
1343   fi
1344 }
1345 # }}}
1346
1347 # mount the new partition or if it's a directory do nothing at all {{{
1348 mount_target() {
1349   if [ -n "$DIRECTORY" ] ; then
1350      einfo "Running grml-debootstrap on a directory, nothing to mount."
1351   else
1352      if grep -q "$TARGET" /proc/mounts ; then
1353         ewarn "$TARGET already mounted, continuing anyway." ; eend 0
1354      else
1355        if ! [ -d "${MNTPOINT}" ] ; then
1356           [ -n "$VIRTUAL" ] || mkdir -p "${MNTPOINT}"
1357        fi
1358        einfo "Mounting $TARGET to $MNTPOINT"
1359        mkdir -p "$MNTPOINT"
1360        mount -o rw,suid,dev "$TARGET" "$MNTPOINT"
1361        eend $?
1362      fi
1363   fi
1364   if [ -n "$ISODIR" ] ; then
1365      einfo "Mounting Debian image loopback to $MNTPOINT/$ISODIR."
1366      mkdir -p "$MNTPOINT/$ISODIR"
1367      mount --bind "$ISODIR" "$MNTPOINT/$ISODIR"
1368      eend $?
1369   fi
1370 }
1371 # }}}
1372
1373 # prepare VM image for usage with debootstrap {{{
1374 prepare_vm() {
1375   if [ -z "$VIRTUAL" ] ; then
1376      return 0 # be quiet by intention
1377   fi
1378
1379   if [ -b "$TARGET" ] && [ -n "$VMFILE" ] ; then
1380      eerror "Error: specified virtual disk target ($TARGET) is an existing block device."
1381      eend 1
1382      bailout 1
1383   fi
1384   if [ ! -b "$TARGET" ] && [ -z "$VMFILE" ] ; then
1385      eerror "Error: specified virtual disk target ($TARGET) does not exist yet."
1386      eend 1
1387      bailout 1
1388   fi
1389
1390   ORIG_TARGET="$TARGET" # store for later reuse
1391
1392   if [ -n "$VMFILE" ]; then
1393     qemu-img create -f raw "${TARGET}" "${VMSIZE}"
1394   fi
1395   parted -s "${TARGET}" 'mklabel msdos'
1396   if [ "$FIXED_DISK_IDENTIFIERS" = "yes" ] ; then
1397     einfo "Adjusting disk signature to a fixed (non-random) value"
1398     MBRTMPFILE=$(mktemp)
1399     dd if="${TARGET}" of="${MBRTMPFILE}" bs=512 count=1
1400     echo -en "\\x41\\x41\\x41\\x41" | dd of="${MBRTMPFILE}" conv=notrunc seek=440 bs=1
1401     dd if="${MBRTMPFILE}" of="${TARGET}" conv=notrunc
1402     eend $?
1403   fi
1404   parted -s "${TARGET}" 'mkpart primary ext4 2M -1'
1405   parted -s "${TARGET}" 'set 1 boot on'
1406
1407   # if dm-mod isn't available then kpartx will fail with
1408   # "Is device-mapper driver missing from kernel? [...]"
1409   if ! kpartx -av "$TARGET" >/dev/null 2>&1 || ! grep -q 'device-mapper' /proc/misc >/dev/null 2>&1 ; then
1410     einfo "Device-mapper not ready yet, trying to load dm-mod module."
1411     modprobe dm-mod ; eend $?
1412   fi
1413
1414   # make sure loop module is present
1415   if ! losetup -f >/dev/null 2>&1; then
1416     einfo "Can not find a usable loop device, retrying after loading loop module."
1417     modprobe loop
1418     if losetup -f >/dev/null 2>&1; then
1419       einfo "Found a usable loop device now, continuing."
1420     else
1421       eerror "Error finding usable loop device" ; eend 1
1422       bailout 1
1423     fi
1424   fi
1425
1426   DEVINFO=$(kpartx -asv "$TARGET") # e.g. 'add map loop0p1 (254:5): 0 20477 linear 7:0 3'
1427   if [ -z "${DEVINFO}" ] ; then
1428     eerror "Error setting up loopback device." ; eend 1
1429     bailout 1
1430   fi
1431
1432   # hopefully this always works as expected
1433   LOOP_PART="${DEVINFO##add map }" # 'loop0p1 (254:5): 0 20477 linear 7:0 3'
1434   LOOP_PART="${LOOP_PART// */}"    # 'loop0p1'
1435   export TARGET="/dev/mapper/$LOOP_PART" # '/dev/mapper/loop1p1'
1436
1437   if [ -z "$TARGET" ] ; then
1438      eerror "Error: target could not be set to according /dev/mapper/* device." ; eend 1
1439      bailout 1
1440   fi
1441 }
1442 # }}}
1443
1444 # make VM image bootable and unmount it {{{
1445 finalize_vm() {
1446   if [ -z "${VIRTUAL}" ] ; then
1447      return 0
1448   fi
1449
1450   if ! mount "${TARGET}" "${MNTPOINT}" ; then
1451     eerror "Error: Mounting ${TARGET} failed, can not continue." ; eend 1
1452     bailout 1
1453   fi
1454
1455   mount -t proc none "${MNTPOINT}"/proc
1456   mount -t sysfs none "${MNTPOINT}"/sys
1457   mount -t devtmpfs udev "${MNTPOINT}"/dev
1458   mount -t devpts devpts "${MNTPOINT}"/dev/pts
1459
1460 # Has chroot-script installed GRUB to MBR using grub-install (successfully), already?
1461 # chroot-script skips installation for unset ${GRUB}
1462 if [[ -z "${GRUB}" ]] || ! dd if="${GRUB}" bs=512 count=1 2>/dev/null | cat -v | grep -Fq GRUB; then
1463   einfo "Installing Grub as bootloader."
1464
1465   if ! chroot "${MNTPOINT}" dpkg --list grub-pc 2>/dev/null | grep -q '^ii' ; then
1466     echo "Notice: grub-pc package not present yet, installing it therefore."
1467     # shellcheck disable=SC2086
1468     DEBIAN_FRONTEND=$DEBIAN_FRONTEND chroot "$MNTPOINT" apt-get -y install $DPKG_OPTIONS grub-pc
1469   fi
1470
1471   mkdir -p "${MNTPOINT}/boot/grub"
1472   if ! [ -d "${MNTPOINT}"/usr/lib/grub/i386-pc/ ] ; then
1473      eerror "Error: grub not installed inside Virtual Machine. Can not install bootloader." ; eend 1
1474      bailout 1
1475   fi
1476
1477   case "$RELEASE" in
1478     lenny|squeeze|wheezy)
1479       cp "${MNTPOINT}"/usr/lib/grub/i386-pc/* "${MNTPOINT}/boot/grub/"
1480       ;;
1481     *)
1482       cp -a "${MNTPOINT}"/usr/lib/grub/i386-pc "${MNTPOINT}/boot/grub/"
1483       ;;
1484   esac
1485   dd if="${MNTPOINT}/usr/lib/grub/i386-pc/boot.img" of="${ORIG_TARGET}" conv=notrunc bs=440 count=1
1486   chroot "${MNTPOINT}" grub-mkimage -O i386-pc -p "(hd0,msdos1)/boot/grub" -o /tmp/core.img biosdisk part_msdos ext2
1487   dd if="${MNTPOINT}/tmp/core.img" of="${ORIG_TARGET}" conv=notrunc seek=1
1488   rm -f "${MNTPOINT}/tmp/core.img"
1489 fi
1490
1491   einfo "Updating grub configuration file."
1492   if [ -n "$BOOT_APPEND" ] ; then
1493      sed -i "/GRUB_CMDLINE_LINUX_DEFAULT/ s#\"\$# ${BOOT_APPEND}\"#" "${MNTPOINT}"/etc/default/grub
1494   fi
1495   chroot "${MNTPOINT}" update-grub
1496
1497   case "$RELEASE" in
1498     jessie)
1499       einfo "Applying workaround for GRUB font path bug in jessie (Debian #787685)."
1500       mkdir -p "${MNTPOINT}/boot/grub/fonts/"
1501       cp "${MNTPOINT}/usr/share/grub/unicode.pf2" "${MNTPOINT}/boot/grub/fonts/"
1502       ;;
1503   esac
1504
1505   if grep -q '^GRUB_DISABLE_LINUX_UUID=.*true' "${MNTPOINT}"/etc/default/grub 2>/dev/null ; then
1506     ewarn "GRUB_DISABLE_LINUX_UUID is set to true in /etc/default/grub, not adjusting root= in grub.cfg."
1507     ewarn "Please note that your system might NOT be able to properly boot."
1508   else
1509     einfo "Adjusting grub.cfg for successful boot sequence."
1510     sed -i "s;root=[^ ]\\+;root=UUID=$TARGET_UUID;" "${MNTPOINT}"/boot/grub/grub.cfg
1511   fi
1512
1513   umount "${MNTPOINT}"/proc
1514   umount "${MNTPOINT}"/sys
1515   umount "${MNTPOINT}"/dev/pts
1516   try_umount 3 "${MNTPOINT}"/dev
1517   umount "${MNTPOINT}"
1518   kpartx -d "${ORIG_TARGET}" >/dev/null
1519 }
1520 # }}}
1521
1522 # install main chroot {{{
1523 debootstrap_system() {
1524   if [ "$_opt_nodebootstrap" ]; then
1525      einfo "Skipping debootstrap as requested."
1526      return
1527   fi
1528
1529   if grep -q "$MNTPOINT" /proc/mounts || [ -n "$DIRECTORY" ] ; then
1530     :
1531   else
1532     eerror "Error: $MNTPOINT not mounted, can not continue."
1533     eend 1 ; exit 1
1534   fi
1535
1536   if [ -n "$ISO" ] ; then
1537     einfo "Running $DEBOOTSTRAP $DEBOOTSTRAP_OPT for release ${RELEASE}${ARCHINFO} using ${ISO}"
1538     einfo "Executing: $DEBOOTSTRAP $ARCHCMD $KEYRING $DEBOOTSTRAP_OPT $RELEASE $MNTPOINT $ISO"
1539     # shellcheck disable=SC2086
1540     "$DEBOOTSTRAP" $ARCHCMD $KEYRING $DEBOOTSTRAP_OPT "$RELEASE" "$MNTPOINT" "$ISO"
1541     RC=$?
1542   else
1543     einfo "Running $DEBOOTSTRAP $DEBOOTSTRAP_OPT for release ${RELEASE}${ARCHINFO} using ${MIRROR}"
1544     einfo "Executing: $DEBOOTSTRAP $ARCHCMD $KEYRING $DEBOOTSTRAP_OPT $RELEASE $MNTPOINT $MIRROR"
1545     # shellcheck disable=SC2086
1546     "$DEBOOTSTRAP" $ARCHCMD $KEYRING $DEBOOTSTRAP_OPT "$RELEASE" "$MNTPOINT" "$MIRROR"
1547     RC=$?
1548   fi
1549
1550   if [ $RC -ne 0 ] ; then
1551     if [ -r "$MNTPOINT/debootstrap/debootstrap.log" ] && \
1552       [ -s "$MNTPOINT/debootstrap/debootstrap.log" ] ; then
1553       einfo "Presenting last ten lines of debootstrap.log:"
1554       tail -10 "${MNTPOINT}"/debootstrap/debootstrap.log
1555       einfo "End of debootstrap.log"
1556     fi
1557   fi
1558
1559   eend $RC
1560 }
1561 # }}}
1562
1563 # prepare chroot via chroot-script {{{
1564 preparechroot() {
1565   einfo "Preparing chroot system"
1566
1567   # provide variables to chroot system
1568   CHROOT_VARIABLES="/var/cache/grml-debootstrap/variables_${SHORT_TARGET}"
1569   touch "$CHROOT_VARIABLES"
1570   chmod 600 "$CHROOT_VARIABLES" # make sure nobody except root can read it
1571   echo "# Configuration of ${PN}"                                                                                   > "$CHROOT_VARIABLES"
1572   # Resorting to sed(1) for escaping since "VAR='${VAR//\'/\'\\\'\'}'" does not work with all versions of Bash,
1573   #   e.g. not with 4.2.37(1)-release (a.k.a 4.2+dfsg-0.1+deb7u3) of Debian wheezy
1574   [ -n "$ARCH" ]                && echo "ARCH='$(sed "s,','\\\\'',g" <<<"${ARCH}")'"                               >> "$CHROOT_VARIABLES"
1575   [ -n "$BACKPORTREPOS" ]       && echo "BACKPORTREPOS='$(sed "s,','\\\\'',g" <<<"${BACKPORTREPOS}")'"             >> "$CHROOT_VARIABLES"
1576   [ -n "$CHROOT_SCRIPTS" ]      && echo "CHROOT_SCRIPTS='$(sed "s,','\\\\'',g" <<<"${CHROOT_SCRIPTS}")'"           >> "$CHROOT_VARIABLES"
1577   [ -n "$COMPONENTS" ]          && echo "COMPONENTS='$(sed "s,','\\\\'',g" <<<"${COMPONENTS}")'"                   >> "$CHROOT_VARIABLES"
1578   [ -n "$CONFFILES" ]           && echo "CONFFILES='$(sed "s,','\\\\'',g" <<<"${CONFFILES}")'"                     >> "$CHROOT_VARIABLES"
1579   [ -n "$DEBCONF" ]             && echo "DEBCONF='$(sed "s,','\\\\'',g" <<<"${DEBCONF}")'"                         >> "$CHROOT_VARIABLES"
1580   [ -n "$DEBIAN_FRONTEND" ]     && echo "DEBIAN_FRONTEND='$(sed "s,','\\\\'',g" <<<"${DEBIAN_FRONTEND}")'"         >> "$CHROOT_VARIABLES"
1581   [ -n "$DEBOOTSTRAP" ]         && echo "DEBOOTSTRAP='$(sed "s,','\\\\'',g" <<<"${DEBOOTSTRAP}")'"                 >> "$CHROOT_VARIABLES"
1582   [ -n "$DEFAULT_LOCALES" ]     && echo "DEFAULT_LOCALES='$(sed "s,','\\\\'',g" <<<"${DEFAULT_LOCALES}")'"         >> "$CHROOT_VARIABLES"
1583   [ -n "$DEFAULT_LANGUAGE" ]    && echo "DEFAULT_LANGUAGE='$(sed "s,','\\\\'',g" <<<"${DEFAULT_LANGUAGE}")'"       >> "$CHROOT_VARIABLES"
1584   [ -n "$EXTRAPACKAGES" ]       && echo "EXTRAPACKAGES='$(sed "s,','\\\\'',g" <<<"${EXTRAPACKAGES}")'"             >> "$CHROOT_VARIABLES"
1585   [ -n "$EFI" ]                 && echo "EFI='$(sed "s,','\\\\'',g" <<<"${EFI}")'"                                 >> "$CHROOT_VARIABLES"
1586   [ -n "$FALLBACK_MIRROR" ]     && echo "FALLBACK_MIRROR='$(sed "s,','\\\\'',g" <<<"${FALLBACK_MIRROR}")'"         >> "$CHROOT_VARIABLES"
1587   [ -n "$FORCE" ]               && echo "FORCE='$(sed "s,','\\\\'',g" <<<"${FORCE}")'"                             >> "$CHROOT_VARIABLES"
1588   [ -n "$GRMLREPOS" ]           && echo "GRMLREPOS='$(sed "s,','\\\\'',g" <<<"${GRMLREPOS}")'"                     >> "$CHROOT_VARIABLES"
1589   [ -n "$GRUB" ]                && echo "GRUB='$(sed "s,','\\\\'',g" <<<"${GRUB}")'"                               >> "$CHROOT_VARIABLES"
1590   [ -n "$HOSTNAME" ]            && echo "HOSTNAME='$(sed "s,','\\\\'',g" <<<"${HOSTNAME}")'"                       >> "$CHROOT_VARIABLES"
1591   [ -n "$INITRD" ]              && echo "INITRD='$(sed "s,','\\\\'',g" <<<"${INITRD}")'"                           >> "$CHROOT_VARIABLES"
1592   [ -n "$INSTALL_NOTES" ]       && echo "INSTALL_NOTES='$(sed "s,','\\\\'',g" <<<"${INSTALL_NOTES}")'"             >> "$CHROOT_VARIABLES"
1593   [ -n "$ISODIR" ]              && echo "ISODIR='$(sed "s,','\\\\'',g" <<<"${ISO}")'"                              >> "$CHROOT_VARIABLES"
1594   [ -n "$ISO" ]                 && echo "ISO='$(sed "s,','\\\\'',g" <<<"${ISO}")'"                                 >> "$CHROOT_VARIABLES"
1595   [ -n "$KEEP_SRC_LIST" ]       && echo "KEEP_SRC_LIST='$(sed "s,','\\\\'',g" <<<"${KEEP_SRC_LIST}")'"             >> "$CHROOT_VARIABLES"
1596   [ -n "$LOCALES" ]             && echo "LOCALES='$(sed "s,','\\\\'',g" <<<"${LOCALES}")'"                         >> "$CHROOT_VARIABLES"
1597   [ -n "$MIRROR" ]              && echo "MIRROR='$(sed "s,','\\\\'',g" <<<"${MIRROR}")'"                           >> "$CHROOT_VARIABLES"
1598   [ -n "$MKFS" ]                && echo "MKFS='$(sed "s,','\\\\'',g" <<<"${MKFS}")'"                               >> "$CHROOT_VARIABLES"
1599   [ -n "$NOPASSWORD" ]          && echo "NOPASSWORD=\"true\""                                                      >> "$CHROOT_VARIABLES"
1600   [ -n "$NOKERNEL" ]            && echo "NOKERNEL=\"true\""                                                        >> "$CHROOT_VARIABLES"
1601   [ -n "$PACKAGES" ]            && echo "PACKAGES='$(sed "s,','\\\\'',g" <<<"${PACKAGES}")'"                       >> "$CHROOT_VARIABLES"
1602   [ -n "$POST_SCRIPTS" ]        && echo "POST_SCRIPTS='$(sed "s,','\\\\'',g" <<<"${POST_SCRIPTS}")'"               >> "$CHROOT_VARIABLES"
1603   [ -n "$PRE_SCRIPTS" ]         && echo "PRE_SCRIPTS='$(sed "s,','\\\\'',g" <<<"${PRE_SCRIPTS}")'"                 >> "$CHROOT_VARIABLES"
1604   [ -n "$RECONFIGURE" ]         && echo "RECONFIGURE='$(sed "s,','\\\\'',g" <<<"${RECONFIGURE}")'"                 >> "$CHROOT_VARIABLES"
1605   [ -n "$RELEASE" ]             && echo "RELEASE='$(sed "s,','\\\\'',g" <<<"${RELEASE}")'"                         >> "$CHROOT_VARIABLES"
1606   [ -n "$RM_APTCACHE" ]         && echo "RM_APTCACHE='$(sed "s,','\\\\'',g" <<<"${RM_APTCACHE}")'"                 >> "$CHROOT_VARIABLES"
1607   [ -n "$ROOTPASSWORD" ]        && echo "ROOTPASSWORD='$(sed "s,','\\\\'',g" <<<"${ROOTPASSWORD}")'"               >> "$CHROOT_VARIABLES"
1608   [ -n "$SCRIPTS" ]             && echo "SCRIPTS='$(sed "s,','\\\\'',g" <<<"${SCRIPTS}")'"                         >> "$CHROOT_VARIABLES"
1609   [ -n "$SECURE" ]              && echo "SECURE='$(sed "s,','\\\\'',g" <<<"${SECURE}")'"                           >> "$CHROOT_VARIABLES"
1610   [ -n "$SELECTED_PARTITIONS" ] && echo "SELECTED_PARTITIONS='$(sed "s,','\\\\'',g" <<<"${SELECTED_PARTITIONS}")'" >> "$CHROOT_VARIABLES"
1611   [ -n "$TARGET" ]              && echo "TARGET='$(sed "s,','\\\\'',g" <<<"${TARGET}")'"                           >> "$CHROOT_VARIABLES"
1612   [ -n "$UPGRADE_SYSTEM" ]      && echo "UPGRADE_SYSTEM='$(sed "s,','\\\\'',g" <<<"${UPGRADE_SYSTEM}")'"           >> "$CHROOT_VARIABLES"
1613   [ -n "$TARGET_UUID" ]         && echo "TARGET_UUID='$(sed "s,','\\\\'',g" <<<"${TARGET_UUID}")'"                 >> "$CHROOT_VARIABLES"
1614   [ -n "$TIMEZONE" ]            && echo "TIMEZONE='$(sed "s,','\\\\'',g" <<<"${TIMEZONE}")'"                       >> "$CHROOT_VARIABLES"
1615   [ -n "$TUNE2FS" ]             && echo "TUNE2FS='$(sed "s,','\\\\'',g" <<<"${TUNE2FS}")'"                         >> "$CHROOT_VARIABLES"
1616   [ -n "$VMSIZE" ]              && echo "VMSIZE='$(sed "s,','\\\\'',g" <<<"${VMSIZE}")'"                           >> "$CHROOT_VARIABLES"
1617
1618   cp $VERBOSE "${CONFFILES}"/chroot-script "${MNTPOINT}"/bin/chroot-script
1619   chmod 755 "${MNTPOINT}"/bin/chroot-script
1620   [ -d "$MNTPOINT"/etc/debootstrap/ ] || mkdir "$MNTPOINT"/etc/debootstrap/
1621
1622   # make sure we have our files for later use via chroot-script
1623   cp $VERBOSE "${CONFFILES}/config"           "${MNTPOINT}"/etc/debootstrap/
1624   # make sure we adjust the configuration variables accordingly:
1625   sed -i "s#RELEASE=.*#RELEASE=\"$RELEASE\"#" "${MNTPOINT}"/etc/debootstrap/config
1626   sed -i "s#TARGET=.*#TARGET=\"$TARGET\"#"    "${MNTPOINT}"/etc/debootstrap/config
1627   sed -i "s#GRUB=.*#GRUB=\"$GRUB\"#"          "${MNTPOINT}"/etc/debootstrap/config
1628
1629   # install notes:
1630   if [ -n "$INSTALL_NOTES" ] ; then
1631      [ -r "$INSTALL_NOTES" ] && cp "$INSTALL_NOTES" "${MNTPOINT}"/etc/debootstrap/
1632   fi
1633
1634   # package selection:
1635   if [ "$PACKAGES" = 'yes' ] ; then
1636     cp $VERBOSE "${_opt_packages:-$CONFFILES/packages}" \
1637       "${MNTPOINT}"/etc/debootstrap/packages
1638   fi
1639
1640   # debconf preseeding:
1641   _opt_debconf=${_opt_debconf:-$CONFFILES/debconf-selections}
1642   [ -f "${_opt_debconf}" ] && [ "$DEBCONF" = 'yes' ] && \
1643     cp $VERBOSE "${_opt_debconf}" "${MNTPOINT}"/etc/debootstrap/debconf-selections
1644
1645   # copy scripts that should be executed inside the chroot:
1646   _opt_chroot_scripts=${_opt_chroot_scripts:-$CONFFILES/chroot-scripts/}
1647   [ -d "$_opt_chroot_scripts" ] && [ "$CHROOT_SCRIPTS" = 'yes' ] && {
1648     mkdir -p "${MNTPOINT}"/etc/debootstrap/chroot-scripts
1649     cp -a $VERBOSE "${_opt_chroot_scripts}"/* "${MNTPOINT}"/etc/debootstrap/chroot-scripts/
1650   }
1651
1652   # notice: do NOT use $CHROOT_VARIABLES inside chroot but statically file instead!
1653   cp $VERBOSE "${CHROOT_VARIABLES}" "${MNTPOINT}"/etc/debootstrap/variables
1654
1655   cp $VERBOSE -a -L "${CONFFILES}"/extrapackages/ "${MNTPOINT}"/etc/debootstrap/
1656
1657   # make sure we can access network [relevant for cdebootstrap]
1658   [ -f "${MNTPOINT}"/etc/resolv.conf ] || cp $VERBOSE /etc/resolv.conf "${MNTPOINT}"/etc/resolv.conf
1659
1660   # setup default locales
1661   [ -n "$LOCALES" ] && cp $VERBOSE "${CONFFILES}"/locale.gen "${MNTPOINT}"/etc/locale.gen
1662
1663   # MAKEDEV is just a forking bomb crap, let's do it on our own instead :)
1664   ( cd "${MNTPOINT}"/dev && tar zxf /etc/debootstrap/devices.tar.gz )
1665
1666   # copy any existing files to chroot
1667   [ -d "${CONFFILES}"/bin   ] && cp $VERBOSE -a -L "${CONFFILES}"/bin/*   "${MNTPOINT}"/bin/
1668   [ -d "${CONFFILES}"/boot  ] && cp $VERBOSE -a -L "${CONFFILES}"/boot/*  "${MNTPOINT}"/boot/
1669   [ -d "${CONFFILES}"/etc   ] && cp $VERBOSE -a -L "${CONFFILES}"/etc/*   "${MNTPOINT}"/etc/
1670   [ -d "${CONFFILES}"/sbin  ] && cp $VERBOSE -a -L "${CONFFILES}"/sbin/*  "${MNTPOINT}"/sbin/
1671   [ -d "${CONFFILES}"/share ] && cp $VERBOSE -a -L "${CONFFILES}"/share/* "${MNTPOINT}"/share/
1672   [ -d "${CONFFILES}"/usr   ] && cp $VERBOSE -a -L "${CONFFILES}"/usr/*   "${MNTPOINT}"/usr/
1673   [ -d "${CONFFILES}"/var   ] && cp $VERBOSE -a -L "${CONFFILES}"/var/*   "${MNTPOINT}"/var/
1674
1675   # network setup
1676   DEFAULT_INTERFACES="# /etc/network/interfaces - generated by grml-debootstrap
1677
1678 # Include files from /etc/network/interfaces.d when using
1679 # ifupdown v0.7.44 or newer:
1680 #source-directory /etc/network/interfaces.d
1681
1682 auto lo
1683 iface lo inet loopback
1684
1685 allow-hotplug eth0
1686 iface eth0 inet dhcp
1687 "
1688
1689   if [ -n "$NOINTERFACES" ] ; then
1690     einfo "Not installing /etc/network/interfaces as requested via --nointerfaces option" ; eend 0
1691   elif [ -n "$USE_DEFAULT_INTERFACES" ] ; then
1692     einfo "Installing default /etc/network/interfaces as requested via --defaultinterfaces options."
1693     echo "$DEFAULT_INTERFACES" > "${MNTPOINT}/etc/network/interfaces"
1694     eend $?
1695   elif [ -n "$VIRTUAL" ] ; then
1696     einfo "Setting up Virtual Machine, installing default /etc/network/interfaces"
1697     echo "$DEFAULT_INTERFACES" > "${MNTPOINT}/etc/network/interfaces"
1698     eend $?
1699   elif [ -r /etc/network/interfaces ] ; then
1700     einfo "Copying /etc/network/interfaces from host to target system"
1701     cp $VERBOSE /etc/network/interfaces "${MNTPOINT}/etc/network/interfaces"
1702     eend $?
1703   else
1704     ewarn "Couldn't read /etc/network/interfaces, installing default /etc/network/interfaces"
1705     echo "$DEFAULT_INTERFACES" > "${MNTPOINT}/etc/network/interfaces"
1706     eend $?
1707   fi
1708
1709   # install config file providing some example entries
1710   if [ -r /etc/network/interfaces.examples ] && [ ! -r "$MNTPOINT/etc/network/interfaces.examples" ] ; then
1711      cp /etc/network/interfaces.examples "$MNTPOINT/etc/network/interfaces.examples"
1712   fi
1713
1714   eend 0
1715 }
1716 # }}}
1717
1718 # execute all scripts in /etc/debootstrap/pre-scripts/ {{{
1719 execute_pre_scripts() {
1720   # make sure hostname is set even before chroot-script get executed
1721   echo "$HOSTNAME" > "$MNTPOINT"/etc/hostname
1722
1723   # make sure we have $MNTPOINT available for our scripts
1724   export MNTPOINT
1725
1726   if [ -d "$_opt_pre_scripts" ] || [ "$PRE_SCRIPTS" = 'yes' ] ; then
1727     [ -d "$_opt_pre_scripts" ] && pre_scripts="$_opt_pre_scripts" || pre_scripts="${CONFFILES}/pre-scripts/"
1728     for script in "${pre_scripts}"/* ; do
1729       if [ -x "$script" ] ; then
1730         einfo "Executing pre-script $script"
1731         "$script" ; eend $?
1732       fi
1733     done
1734   fi
1735 }
1736 # }}}
1737
1738 # execute all scripts in /etc/debootstrap/post-scripts/ {{{
1739 execute_post_scripts() {
1740   # make sure we have $MNTPOINT and HOSTNAME available for our scripts
1741   export MNTPOINT
1742   export TARGET_HOSTNAME=$HOSTNAME
1743
1744   if [ -d "$_opt_scripts" ] || [ "$SCRIPTS" = 'yes' ] ; then
1745     # legacy support for /etc/debootstrap/scripts/
1746     [ -d "$_opt_scripts" ] && post_scripts="$_opt_scripts" || post_scripts="${CONFFILES}/scripts/"
1747     ewarn "Deprecation NOTE: --scripts/SCRIPTS are deprecated, please switch to --post-scripts/POST_SCRIPTS instead."
1748   elif [ -d "$_opt_post_scripts" ] || [ "$POST_SCRIPTS" = 'yes' ] ; then
1749     [ -d "$_opt_post_scripts" ] && post_scripts="$_opt_post_scripts" || post_scripts="${CONFFILES}/post-scripts/"
1750   fi
1751
1752   if [ -n "$post_scripts" ] ; then
1753     for script in "${post_scripts}"/* ; do
1754       if [ -x "$script" ] ; then
1755         einfo "Executing post-script $script"
1756         "$script" ; eend $?
1757       fi
1758     done
1759   fi
1760 }
1761 # }}}
1762
1763 # unmount mountpoint {{{
1764 try_umount() {
1765   local tries=$1
1766   local mountpoint="$2"
1767
1768   for (( try=1; try<=tries; try++ )); do
1769     if [[ ${try} -eq ${tries} ]]; then
1770       # Last time, show errors this time
1771       umount "${mountpoint}" && return 0
1772     else
1773       # Not last time, hide errors until fatal
1774       if umount "${mountpoint}" 2>/dev/null ; then
1775         return 0
1776       else
1777         sleep 1
1778       fi
1779     fi
1780   done
1781   return 1  # Tried enough
1782 }
1783 # }}}
1784
1785 # execute chroot-script {{{
1786 chrootscript() {
1787   if ! [ -r "$MNTPOINT/bin/chroot-script" ] ; then
1788     mount_target
1789   fi
1790
1791   if ! [ -x "$MNTPOINT/bin/chroot-script" ] ; then
1792     eerror "Fatal: $MNTPOINT/bin/chroot-script could not be found."
1793     eend 1
1794   else
1795     einfo "Executing chroot-script now"
1796     mount -t devtmpfs udev "${MNTPOINT}"/dev
1797     mount -t devpts devpts "${MNTPOINT}"/dev/pts
1798     if [ "$DEBUG" = "true" ] ; then
1799       chroot "$MNTPOINT" /bin/bash -x /bin/chroot-script ; RC=$?
1800     else
1801       chroot "$MNTPOINT" /bin/chroot-script ; RC=$?
1802     fi
1803     try_umount 3 "$MNTPOINT"/dev/pts
1804     try_umount 3 "$MNTPOINT"/dev
1805     eend $RC
1806   fi
1807
1808   # finally get rid of chroot-script again, there's no good reason to
1809   # keep it on the installed system
1810   if grep -q GRML_CHROOT_SCRIPT_MARKER "${MNTPOINT}/bin/chroot-script" ; then
1811     einfo "Removing chroot-script again"
1812     rm -f "${MNTPOINT}/bin/chroot-script"
1813     eend $?
1814   else
1815     einfo "Keeping chroot-script as string GRML_CHROOT_SCRIPT_MARKER could not be found"
1816     eend 0
1817   fi
1818 }
1819 # }}}
1820
1821 # unmount $MNTPOINT {{{
1822 umount_chroot() {
1823
1824   # display installation notes:
1825   if [ -n "$INSTALL_NOTES" ] ; then
1826      [ -r "${MNTPOINT}/${INSTALL_NOTES}" ] && cat "${MNTPOINT}/${INSTALL_NOTES}"
1827   fi
1828
1829   if [ -n "$ISODIR" ] ; then
1830      if grep -q "$ISODIR" /proc/mounts ; then
1831         einfo "Unmount $MNTPOINT/$ISODIR"
1832         umount "$MNTPOINT/$ISODIR"
1833         eend $?
1834      fi
1835   fi
1836
1837   if grep -q "$MNTPOINT" /proc/mounts ; then
1838      if [ -n "$PARTITION" ] ; then
1839         einfo "Unmount $MNTPOINT"
1840         umount "$MNTPOINT"
1841         eend $?
1842      fi
1843   fi
1844 }
1845 # }}}
1846
1847 # execute filesystem check {{{
1848 fscktool() {
1849  if [ -n "$VIRTUAL" ] ; then
1850    einfo "Skipping filesystem check because we deploy a virtual machine."
1851    return 0
1852  fi
1853
1854  if [ "$FSCK" = 'yes' ] ; then
1855    [ -n "$FSCKTOOL" ] || FSCKTOOL="fsck.${MKFS#mkfs.}"
1856    einfo "Checking filesystem on $TARGET using $FSCKTOOL"
1857    "$FSCKTOOL" "$TARGET"
1858    eend $?
1859  fi
1860 }
1861 # }}}
1862
1863 # get rid of grml-debootstrap config files {{{
1864 remove_configs() {
1865   if [ "$REMOVE_CONFIGS" != "yes" ] ; then
1866     return 0
1867   fi
1868
1869   if ! mountpoint "${MNTPOINT}" >/dev/null 2>&1 ; then
1870     ewarn "Target ${MNTPOINT} doesn't seem to be mounted, can't remove configuration files." ; eend 0
1871     return 0
1872   fi
1873
1874   einfo "Removing configuration files from installed system as requested via --remove-configs / REMOVE_CONFIGS."
1875   rm -rf "${MNTPOINT}"/etc/debootstrap/
1876   eend $?
1877 }
1878 # }}}
1879
1880 # now execute all the functions {{{
1881 for i in format_efi_partition prepare_vm mkfs tunefs \
1882          mount_target mountpoint_to_blockdevice debootstrap_system \
1883          preparechroot execute_pre_scripts chrootscript execute_post_scripts \
1884          remove_configs umount_chroot finalize_vm fscktool ; do
1885     if stage "${i}" ; then
1886       if "$i" ; then
1887         stage "${i}" 'done' && rm -f "${STAGES}/${i}"
1888       else
1889         bailout 2 "$i"
1890       fi
1891     fi
1892 done
1893
1894 cleanup
1895 # }}}
1896
1897 # end dialog of autoinstallation {{{
1898 if [ -n "$AUTOINSTALL" ] ; then
1899    if dialog --title "${PN}" --pause "Finished execution of ${PN}.
1900 Automatically rebooting in 10 seconds.
1901
1902 Choose Cancel to skip rebooting." 10 60 10 ; then
1903      noeject noprompt reboot
1904   fi
1905 else
1906    einfo "Finished execution of ${PN}. Enjoy your Debian system." ; eend 0
1907 fi
1908 # }}}
1909
1910 ## END OF FILE #################################################################
1911 # vim: ai tw=100 expandtab foldmethod=marker shiftwidth=2